# Instalan skript pro Fraktlnk
	
!define Jmno "Fraktlnk"
!define Verze "6.0.2"
!define KrtkJmno ${Jmno}
!define VERZE_JRE "1.8.0"
!define VERZE_JRE_PO ${VERZE_JRE}

!define Dodavatel "Pikvorky software"
!define JreInstProgram "jre-8u31-windows-x64.exe"
;!define JreInstProgram "haha.exe"


# Obecn nastaven
  !include "MUI2.nsh"
  !include "InstallOptions.nsh"

  Var InstalovatJRE
  Var CestaJRE
 

  OutFile "Instalace.exe"

# Implicitn instalan adres
  InstallDir "C:\Temp\Fraktl"
  Name ${KrtkJmno}
  Caption "Program pro vpoet fraktl"
  
  !define MUI_ABORTWARNING
  RequestExecutionLevel admin

# Strnky prvodce instalac
#
# vodn strnka
  !define MUI_WELCOMEPAGE_TITLE "Vtejte v prvodci instalac programu ${KrtkJmno}"
  !define MUI_WELCOMEPAGE_TEXT "Tento prvodce vs provede instalac programu ${KrtkJmno}.$\n$\n$\n${KrtkJmno} je program, kter umouje kreslit a studovat fraktly a ukldat vytvoen obrzky fraktl do soubor. $\n$\n$\nChcete-li pokraovat, stisknte tlatko Dal."
  !insertmacro MUI_PAGE_WELCOME 

# Licenn ujednn
  !insertmacro MUI_PAGE_LICENSE "Licence.rtf"

# Test a ppadn instalace javy
  Page custom KontrolaInstalaceJRE

  !define MUI_PAGE_HEADER_TEXT "Instalace bhovho prosted Javy"
  !define MUI_PAGE_HEADER_SUBTEXT "Prosm pokejte na dokonen instalace Javy" 
  !insertmacro MUI_PAGE_INSTFILES

# Volba instalovanch soust 
  !define MUI_COMPONENTSPAGE_TEXT_TOP "Sousti, kter chcete instalovat, zakrtnte. Sousti, kter nechcete instalovat, nechte nezakrtnut nebo u nich zrute zakrtnut."
  !define MUI_COMPONENTSPAGE_TEXT_DESCRIPTION_INFO "Ukete-li my na soust, zde se zobraz jej popis. "
  !insertmacro MUI_PAGE_COMPONENTS   

# uren dlov sloky
  !define MUI_DIRECTORYPAGE_TEXT_TOP "Prvodce se chyst instalovat program ${KrtkJmno} do zvolen sloky. Chcete-li pout jinou ne uvedenou sloky, stiknte tlatko Prochzet nebo pepite cestu sloky. Stisknutm tlatka Instalovat spustte instalaci."
  !insertmacro MUI_PAGE_DIRECTORY

#Prbh instalace Fraktlnku
 !define MUI_PAGE_HEADER_TEXT "Instalace programu ${KrtkJmno}"
 !define MUI_PAGE_HEADER_SUBTEXT "Prosm pokejte na dokonen instalace programu ${KrtkJmno}" 
 !insertmacro MUI_PAGE_INSTFILES

# Zvren strnka prvodce
  !define MUI_FINISHPAGE_TITLE "Dokonen instalace programu ${KrtkJmno}"  
  !define MUI_INSTFILESPAGE_FINISHHEADER_TEXT "Instalace dokonena"
  !insertmacro MUI_PAGE_FINISH


  !define MUI_UNCONFIRMPAGE_TEXT_TOP "Jestlie chcete odinstalovat program\
 ${KrtkJmno} ze svho potae, stisknte tlatko Odinstalovat.$\n$\nChcete-li\
 tuto akci zruit, stisknte tlatko Storno." 
  
  

# Strnky prvodce odinstalac
#
# vodn strnka odinstaltoru
  !define MUI_PAGE_HEADER_TEXT "Odebrn programu ${KrtkJmno}"
  !define MUI_PAGE_HEADER_SUBTEXT "Opravdu chcete ostranit program ${KrtkJmno} ze svho potae?"
  !insertmacro MUI_UNPAGE_CONFIRM

# Prbh odstraovn
  !insertmacro MUI_UNPAGE_INSTFILES


# Jazyk instalace
  !insertmacro MUI_LANGUAGE "Czech"

# Ikona instalanho a odinstalanho programu
  Icon ikona\Netopr.ico
  UninstallIcon ikona\Netopr1.ico


;--------------------------------
#Sekce

Section -InstalaceJre jre
  Push $0
  Push $1
  ;MessageBox MB_OK "Sekce instalace JRE"
  Strcmp $InstalovatJRE "ano" InstalujJRE Konec
  DetailPrint "Spoutn instalace JRE"

InstalujJRE:
  File /oname=$TEMP\${JreInstProgram} ${JreInstProgram}
  ;MessageBox MB_OK "Instalace JRE"
  DetailPrint "Instalace JRE sputna"
  ExecWait '"$TEMP\${JreInstProgram}" /s /v\"/qn REBOOT=Suppress JAVAUPDATE=0 WEBSTARTICON=0\"' $0
  DetailPrint "Instalace JRE dokonena"
  Delete "$TEMP\${JreInstProgram}"
  ;MessageBox MB_OK "Kd ukonen instalanho programu: $0"
  StrCmp $0 "0" OvenInstalace 0
  Push "Instalace JRE byla abnormln ukonena."
  Goto ZruInstalaciJRE
 
OvenInstalace:
  DetailPrint "Kontrola vsledku instalace JRE"
  ;MessageBox MB_OK "Kontrola vsledku instalace JRE"
  Push "${VERZE_JRE_PO}"
  Call DetekceJRE  
  Pop $0	  ; Zjitn hodnoty JRE
  ;MessageBox MB_OK "Kontrola vsledku instalace JRE: $0"
  StrCmp $0 "0" ZruInstalaciJRE 0
  StrCmp $0 "-1" ZruInstalaciJRE 0
  ;Goto OvenJavaExe
  Goto Konec
  Push "Instalace JRE se nezdaila"
  Goto ZruInstalaciJRE
 
;OvenJavaExe:
  ;MessageBox MB_OK "Verifikace: $0"
  ;IfFileExists $0 Konec 0
  ;Push "Soubor : $0 nenalezen"
  ;Goto ZruInstalaciJRE
 
ZruInstalaciJRE:
  Pop $1
  MessageBox MB_OK "Instalace bude ukonena z dvodu : $1"
  Pop $1 	; Restore $1
  Pop $0 	; Restore $0
  Abort

Konec:
  Pop $1	; Restore $1
  Pop $0	; Restore $0
  MessageBox MB_OK "Konec sekce instalace Javy - CestaJRE: $CestaJRE"
SectionEnd

Section "!Program ${KrtkJmno}" SekceProgram
  SectionIn RO
  ;instalan adres
  SetOutPath "$INSTDIR" 

  ;seznam soubor koprovanch do tohoto adrese
   File fraktal6_0_2.jar
   SetOutPath "$INSTDIR\ikona"
   File ikona\*.*
   
  ;Vytvoen programu pro odstrann aplikace
  WriteUninstaller "$INSTDIR\Odinstaluj.exe"

# Zpis adrese s instalac do registru
  WriteRegStr HKCU "Software\${KrtkJmno}" "Install_Dir" $INSTDIR

# Zpis informac pro odinstalaci z ovldacch panel do registru
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${KrtkJmno}" "DisplayName" "${KrtkJmno} (lze pouze odstranit)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${KrtkJmno}" "DisplayVersion" "6.0.2.0" 
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${KrtkJmno}" "Publisher" "${Dodavatel}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${KrtkJmno}" "UninstallString" '"$INSTDIR\Odinstaluj.exe"'
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${KrtkJmno}" "DisplayIcon" '"$INSTDIR\ikona\Netopr2.ico"'
SectionEnd

Section "Zstupce na ploe" SekceZstupce
# Vytvoen zstupce na ploe
  CreateShortCut "$DESKTOP\${KrtkJmno}.lnk" '$INSTDIR\fraktal6_0_2.jar' "" "$INSTDIR\ikona\Netopr2.ico" 0
SectionEnd

Section "Poloka v nabdce Start" SekceMenuStart
# Poloka v nabdce start
  CreateDirectory "$SMPROGRAMS\${KrtkJmno}"
  CreateShortCut "$SMPROGRAMS\${KrtkJmno}\${KrtkJmno}.lnk" "$INSTDIR\fraktal6_0_2.jar" "" "$INSTDIR\ikona\Netopr2.ico" 0
  ;CreateShortCut "$SMPROGRAMS\${KrtkJmno}\Odinstaluj.lnk" "$INSTDIR\Odinstaluj.exe" "" "$INSTDIR\ikona\Netopr1.ico" 
SectionEnd

Section /o "Dokumentace" SekceDokumentace
   SetOutPath "$INSTDIR\doc"
   File doc\*.*
SectionEnd

Section /o "Knihovna" SekceKnihovna
   SetOutPath "$INSTDIR\knihovna"
   File /r knihovna\*.*
SectionEnd


;--------------------------------
# Sekce odinstaltoru

Section "Uninstall"
  # Zde vypeme odstraovan soubory...
  RMDir /r "$INSTDIR"
  Delete "$DESKTOP\${KrtkJmno}.lnk"
  RmDir /r "$SMPROGRAMS\${KrtkJmno}"
  DeleteRegKey HKCU "Software\${KrtkJmno}"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${KrtkJmno}"
SectionEnd

# Popis sekc
  LangString DESC_SekceProgram ${LANG_Czech} \
      "Hlavn program, fraktly a npovda"
  LangString DESC_SekceDokumentace ${LANG_Czech} \
      "Pruka uivatele a licenn ujednn"
  LangString DESC_SekceKnihovna ${LANG_Czech} \
      "Knihovna pro vytven vlastnch td \
      fraktl a dokumentace k n"
  LangString DESC_SekceZstupce ${LANG_Czech} \
      "Vytvoen zstupce programu ${KrtkJmno} na ploe"
  LangString DESC_SekceMenuStart ${LANG_Czech} \
      "Vytvoen skupiny a poloky pro ${KrtkJmno} v nabdce Start Windows"

  LangString TITULEK_JRE ${LANG_Czech} "Bhov prosted Javy"
  LangString PODTITULEK_JRE ${LANG_Czech} "Pro sprvnou funkci aplikace ${KrtkJmno} je potebn instalace JRE ${VERZE_JRE}"


# Piazen etzc v danm jazyce sekcm
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SekceProgram} $(DESC_SekceProgram)
    !insertmacro MUI_DESCRIPTION_TEXT ${SekceDokumentace} $(DESC_SekceDokumentace) 
    !insertmacro MUI_DESCRIPTION_TEXT ${SekceKnihovna} $(DESC_SekceKnihovna) 
    !insertmacro MUI_DESCRIPTION_TEXT ${SekceZstupce} $(DESC_SekceZstupce)
    !insertmacro MUI_DESCRIPTION_TEXT ${SekceMenuStart} $(DESC_SekceMenuStart)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END


Function .onInit
  MessageBox MB_OK "Funkce onInit: $TEMP"
  ;Peteme soubor .ini pro InstallOptions  
  !insertmacro INSTALLOPTIONS_EXTRACT "jre.ini"
  ;Call UpravNastavenSekc
FunctionEnd
 
Function KontrolaInstalaceJRE
  ;MessageBox MB_OK "Kontrola instalovan verze JRE"
  Push "${VERZE_JRE}"
  Call DetekceJRE
  ;Messagebox MB_OK "Kontrola verze JRE dokonena"
  Exch $0	; Zskej hodnotu ze zsobnku
  StrCmp $0 "0" Nenalezeno
  StrCmp $0 "-1" NalezenaStar
  Goto JREJiInstalovna
 
NalezenaStar:
  ;MessageBox MB_OK "Zjitna star verze Javy"
  !insertmacro INSTALLOPTIONS_WRITE "jre.ini" "Field 1" "Text" "${KrtkJmno} vyaduje novj verzi bhovho prosted Javy, ne \
   jak byla zjitna\nna vaem potai. Stisknete-li tlatko Instalovat, bude sputna instalace JRE ${VERZE_JRE}. \n\
   Stisknutm tlatka Storno zrute instalaci JRE i aplikace ${KrtkJmno}."
  !insertmacro MUI_HEADER_TEXT "$(TITULEK_JRE)" "$(PODTITULEK_JRE)"
  !insertmacro INSTALLOPTIONS_DISPLAY_RETURN "jre.ini"
  Goto NutnoInstalovatJRE
 
Nenalezeno:
  ;MessageBox MB_OK "Java nebyla nalezena"
  !insertmacro INSTALLOPTIONS_WRITE "jre.ini" "Field 1" "Text" "Na vaem potai nebyla nalezena Java. Bude sputna instalace \
    JRE ${VERZE_JRE}.\nStisknutm tlatka Storno zrute instalaci JRE i aplikace ${KrtkJmno}."
  !insertmacro MUI_HEADER_TEXT "$(TITULEK_JRE)" "$(PODTITULEK_JRE)"
  !insertmacro INSTALLOPTIONS_DISPLAY_RETURN "jre.ini"
  Goto NutnoInstalovatJRE
 
NutnoInstalovatJRE:
  Exch $0
  Pop $0	; Obnov $0
  StrCpy $InstalovatJRE "ano"
  Return
 
JREJiInstalovna:
  ;MessageBox MB_OK "Java je ji instalovna, $0"
  StrCpy $InstalovatJRE "ne"
  StrCpy $CestaJRE $0
  ;MessageBox MB_OK "Java je ji instalovna, $CestaJRE"
  ;!insertmacro INSTALLOPTIONS_WRITE "jre.ini" "UserDefinedSection" "JREPath" $1
  Pop $0		; Obnov $0
  Return
FunctionEnd


Function DetekceJRE
  ;MessageBox MB_OK "Detekce JRE"
  Exch $0	; Zjisti poadovanou verzi  
		; Te je pedchoz hodnota $0 v zsobnku a poadovan verze JDK je v $0
  Push $1	; $1 = etzec s verz Javy (nap. 1.5.0)
  Push $2	; $2 = Javahome
  Push $3	; $3 a $4 se pouij pro kontrolu hlavn/vedlej verze Javy
  Push $4
  ;MessageBox MB_OK "Detekce JRE"
  ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment" "CurrentVersion"
  ;MessageBox MB_OK "Peteno : $1"
  StrCmp $1 "" Detekce2
  ReadRegStr $2 HKLM "SOFTWARE\JavaSoft\Java Runtime Environment\$1" "JavaHome"
  ;MessageBox MB_OK "Peteno 3: $2"
  StrCmp $2 "" Detekce2
  Goto PorovnejVerze
 
Detekce2:
  ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
  ;MessageBox MB_OK "Detekce - teno: $1"
  StrCmp $1 "" Nenalezeno
  ReadRegStr $2 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
  ;MessageBox MB_OK "Detekce - teno 3: $2"
  StrCmp $2 "" Nenalezeno
 
PorovnejVerze:
; $0 = poadovan verze, $1 = nalezen verze, $2 = javaHome
  ;MessageBox MB_OK "Hledm JRE"
  IfFileExists "$2\bin\java.exe" 0 Nenalezeno
  StrCpy $3 $0 1			; Zjisti hlavn slo verze. Nap.: $1 = 1.5.0, nyn $3 = 1
  StrCpy $4 $1 1			; $3 = hlavn verze poadovan, $4 = hlavn verze nalezen
  ;MessageBox MB_OK "Poadovno $3 , nalezeno $4"
  IntCmp $4 $3 0 NalezenaStar NalezenaNov
  StrCpy $3 $0 1 2
  StrCpy $4 $1 1 2			; Jako pedtm. $3 je vedlej poadovan verze, $4 je vedlej instalovan verze
  ;MessageBox MB_OK "Poadovno $3 , nalezeno $4" 
  IntCmp $4 $3 NalezenaNov NalezenaStar NalezenaNov
 
Nenalezeno:
  ;MessageBox MB_OK "JRE nenalezeno"
  Push "0"
  Goto KonecDetekceJRE
 
NalezenaStar:
   ;MessageBox MB_OK "JRE zastaral: $3 je star ne $4"
;  Push ${TEMP2}
  Push "-1"
  Goto KonecDetekceJRE  

NalezenaNov:
  ;MessageBox MB_OK "Nov JRE: $3 je novj ne $4"
   StrCpy $CestaJRE "$2\bin\java.exe"
   Push $CestaJRE
   ;MessageBox MB_OK "$2\bin\java.exe"
   Goto KonecDetekceJRE

KonecDetekceJRE:
	; Na vrcholu zsobnku je nvratov hodnota, pak r4,r3,r2,r1
	Exch	; => r4,rv,r3,r2,r1,r0
	Pop $4	; => rv,r3,r2,r1r,r0
	Exch	; => r3,rv,r2,r1,r0
	Pop $3	; => rv,r2,r1,r0
	Exch 	; => r2,rv,r1,r0
	Pop $2	; => rv,r1,r0
	Exch	; => r1,rv,r0
	Pop $1	; => rv,r0
	Exch	; => r0,rv
	Pop $0	; => rv 
FunctionEnd

