# Instalan skript pro Fraktl.exe


 Var Knihovna
# Obecn nastaven
  !include "MUI2.nsh"
  OutFile "Instalace.exe"

# Implicitn instalan adres
  InstallDir "C:\Temp\Fraktl"
  Name "Fraktlnk"
  Caption "Program pro vpoet fraktl"
  
  !define MUI_ABORTWARNING
  RequestExecutionLevel admin

# Strnky prvodce instalac
   !define MUI_WELCOMEPAGE_TITLE "Vtejte v prvodci instalac \
 programu Fraktlnk"
  !define MUI_WELCOMEPAGE_TEXT "Tento prvodce vs provede \
 instalac programu Fraktlnk.$\n$\n$\nFraktlnk je program, \
 kter umouje kreslit a studovat fraktly a ukldat vytvoen \
 obrzky fraktl do soubor.\
 $\n$\n$\nChcete-li pokraovat, stisknte tlatko Dal."
 

  !define MUI_COMPONENTSPAGE_TEXT_TOP "Sousti, kter chcete instalovat, zakrtnte. Sousti, kter nechcete instalovat, nechte nezakrtnut nebo u nich zrute zakrtnut."

  !define MUI_COMPONENTSPAGE_TEXT_DESCRIPTION_INFO "Ukete-li my na soust, zde se zobraz jej popis. "
  !define MUI_DIRECTORYPAGE_TEXT_TOP "Prvodce nyn nainstaluje program Fraktlnk do zvolenho adrese. Chcete-li pout jin ne uveden adres, stiknte tlatko prochzet. Stisknutm tlatka Instalovat spustte instalaci."

  !define MUI_FINISHPAGE_TITLE "Dokonen instalace programu Fraktlnk"  

  !define MUI_UNCONFIRMPAGE_TEXT_TOP "Jestlie chcete odinstalovat program\
 Fraktlnk ze svho potae, stisknte tlatko Odinstalovat.$\n$\nChcete-li\
 tuto akci zruit, stisknte tlatko Storno." 

  !define MUI_WELCOMEFINISHPAGE_BITMAP "Strom4.bmp"

  !insertmacro MUI_PAGE_WELCOME
  ;!define MUI_LICENSEPAGE_CHECKBOX
  !insertmacro MUI_PAGE_LICENSE "Licence.rtf"

  !define MUI_PAGE_HEADER_TEXT "Zvolte sousti"
  !define MUI_PAGE_HEADER_SUBTEXT "Na tto strnce zvolte \
    sousti aplikace, kter chcete instalovat."
  !insertmacro MUI_PAGE_COMPONENTS

  !define MUI_PAGE_HEADER_TEXT "Zvolte umstn aplikace Fraktlnk"
  !define MUI_PAGE_HEADER_SUBTEXT "Vyberte adres, do kterho bude aplikace Fraktlnk instalovna."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Domovsk adres aplikace"
  !insertmacro MUI_PAGE_DIRECTORY

  !define MUI_PAGE_HEADER_TEXT "Zvolte umstn knihovny"
  !define MUI_PAGE_HEADER_SUBTEXT "Vyberte adres, do kterho bude knihovna pro vvoj fraktl instalovna."
  !define MUI_DIRECTORYPAGE_TEXT_TOP "Poadujete instalaci knihovny pro vlastn vvoj td pro vpoet fraktl. Urete adres, do nho bude tato knihovna uloena."
  !define MUI_DIRECTORYPAGE_TEXT_DESTINATION "Umstn knihovny pro vvoj fraktl"
  !define MUI_DIRECTORYPAGE_VARIABLE $Knihovna
  !define MUI_PAGE_CUSTOMFUNCTION_PRE zdaZobrazit
  !insertmacro MUI_PAGE_DIRECTORY

 
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

# Strnky prvodce deinstalac
  !define MUI_PAGE_HEADER_TEXT "Odebrn programu Fraktlnk"
  !define MUI_PAGE_HEADER_SUBTEXT "Opravdu chcete ostranit program Fraktlnk ze svho potae?"
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES

  !insertmacro MUI_LANGUAGE "Czech"

# Ikona instalanho a odinstalanho programu
  Icon ikona\Netopr.ico
  UninstallIcon ikona\Netopr1.ico


;--------------------------------
#Sekce

Section "!Program Fraktlnk" Sekce1
  SectionIn RO
  ;instalan adres
  SetOutPath "$INSTDIR" 

  ;seznam soubor koprovanch do tohoto adrese
   File fraktal6_0_2.jar
   SetOutPath "$INSTDIR\ikona"
   File ikona\*.*

   SetOutpath "$INSTDIR\lib"
   File lib\Knihovna.jar
   
  ;Vytvoen programu pro odstrann aplikace
  WriteUninstaller "$INSTDIR\Odinstaluj.exe"

# Vytvoen zstupce na ploe
  CreateShortCut "$DESKTOP\Fraktlnk.lnk" '$INSTDIR\fraktal6_0_2.jar' "" "$INSTDIR\ikona\Netopr2.ico" 0

# Poloka v nabdce start
  CreateDirectory "$SMPROGRAMS\Fraktlnk"
  CreateShortCut "$SMPROGRAMS\Fraktlnk\Fraktlnk.lnk" "$INSTDIR\fraktal6_0_2.jar" "" "$INSTDIR\ikona\Netopr2.ico" 0
  ;CreateShortCut "$SMPROGRAMS\Fraktlnk\Odinstaluj.lnk" "$INSTDIR\Odinstaluj.exe" "" "$INSTDIR\ikona\Netopr1.ico" 

# Zpis adrese s instalac do registru
  WriteRegStr HKCU "Software\Fraktlnk" "Install_Dir" $INSTDIR

# Zpis informac pro odinstalaci z ovldacch panel do registru
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Fraktlnk" "DisplayName" "Fraktlnk (lze pouze odstranit)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Fraktlnk" "DisplayVersion" "6.0.2.0" 
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Fraktlnk" "Publisher" "Pikvorky software"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Fraktlnk" "UninstallString" '"$INSTDIR\Odinstaluj.exe"'
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Fraktlnk" "DisplayIcon" '"$INSTDIR\ikona\Netopr2.ico"'


SectionEnd


Section /o "Dokumentace" Sekce2
   SetOutPath "$INSTDIR\doc"
   File doc\*.*
SectionEnd

Section /o "Knihovna" Sekce3
   ;MessageBox MB_OK "$Knihovna"
   SetOutPath "$Knihovna"
   File /r lib\*.*
SectionEnd

;--------------------------------
# Sekce odinstaltoru

Section "Uninstall"

  # Zde vypeme odstraovan soubory...

  RMDir /r "$INSTDIR"
  Delete "$DESKTOP\Fraktlnk.lnk"
  RmDir /r "$SMPROGRAMS\Fraktlnk"
  DeleteRegKey HKCU "Software\Fraktlnk"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Fraktlnk"

SectionEnd

# Popis sekc
  LangString DESC_Sekce1 ${LANG_Czech} \
      "Hlavn program, fraktly a npovda"
  LangString DESC_Sekce2 ${LANG_Czech} \
      "Pruka uivatele a licenn ujednn"
  LangString DESC_Sekce3 ${LANG_Czech} \
      "Knihovna pro vytven vlastnch td \
      fraktl a dokumentace k n"


# Piazen etzc v danm jazyce sekcm
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${Sekce1} $(DESC_Sekce1)
    !insertmacro MUI_DESCRIPTION_TEXT ${Sekce2} $(DESC_Sekce2) 
    !insertmacro MUI_DESCRIPTION_TEXT ${Sekce3} $(DESC_Sekce3) 
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

Function zdaZobrazit
  ${Unless} ${SectionIsSelected} ${Sekce3}
    Abort
  ${EndUnless}
  StrCpy $Knihovna "$INSTDIR\knihovna"
FunctionEnd